/* copyright (c)2012 Oskar Schirmer <oskar@scara.com> */
#ifndef _ARITHLOG_H
#define _ARITHLOG_H

#define crc32_word(crc, data, poly) \
  __asm__ __volatile__ ( \
  "crc32 %0, %1, %2" : "+r" (crc) : "r" (data), "r" (poly))

#define crc32_byte(crc, data, poly) \
  ({ unsigned r; \
  __asm__ __volatile__ ( \
  "crc8 %1, %0, %2, %3" \
  : "=r" (r), "+r" (crc) : "r" (data), "r" (poly)); \
  r; })

static inline unsigned byterev(const unsigned val)
{
  unsigned res;
  __asm__ __volatile__ ("byterev %0, %1" : "=r" (res) : "r" (val));
  return res;
}

static inline unsigned bitrev(const unsigned val)
{
  unsigned res;
  __asm__ __volatile__ ("bitrev %0, %1" : "=r" (res) : "r" (val));
  return res;
}

#endif
