/* copyright (c)2012 Oskar Schirmer <oskar@scara.com> */
#ifndef _CHANEND_H
#define _CHANEND_H

#include "arithlog.h"
#include "resource.h"

static inline void chanend_write_lsb(const resource chanend,
    const unsigned char *data, const unsigned count)
{
  unsigned n = 0;
  while ((n < count) && (((unsigned)data) & 3)) {
    chanend_write_byte(chanend, data[n++]);
  }
  while ((n + 4) <= count) {
    chanend_write_word(chanend, byterev(*(unsigned *)&data[n]));
    n += 4;
  }
  while (n < count) {
    chanend_write_byte(chanend, data[n++]);
  }
}

static inline unsigned chanend_read_lsb(const resource chanend,
    unsigned char *data, const unsigned limit)
{
  unsigned n = 0;
  while ((n <= (limit - 1)) && !chanend_nomore_byte(chanend)) {
    data[n++] = chanend_read_byte(chanend);
  }
  return n;
}

static inline unsigned chanend_read_strip(const resource chanend)
{
  unsigned n = 0;
  while (!chanend_nomore_byte(chanend)) {
    chanend_read_byte(chanend);
    n++;
  }
  return n;
}

#endif
