/* copyright (c)2013 Oskar Schirmer <oskar@scara.com> */
#ifndef _EXECUSER_H
#define _EXECUSER_H

#include "chanend.h"
#include "dispatch.h"
#include "ethernet.h"
#include "reception.h"
#include "resource.h"

static inline resource execuser(char *name)
{
  int i, e;
  char c;
  resource s, x, ctrl;
  unsigned char data[16];
  s = chanend_book();
  e = 3;
  do {
    chanend_connect(s, chanend_cr_request(s, cr_eth_tftp));
    chanend_write_byte(s, 'R');
    i = 0;
    while (c = name[i++]) {
      chanend_write_byte(s, c);
    }
    chanend_all_sent(s);
    i = chanend_read_lsb(s, &data[0], 16);
    if (i == 16) {
      x = chanend_book();
      chanend_connect(x, chanend_cr_request(x, cr_init_dispatch));
      chanend_write_byte(x, dp_cmd_task);
      chanend_write_lsb(x, &data[0], 16);
      while (!chanend_nomore_byte(s)) {
        chanend_write_byte(x, chanend_read_byte(s));
        i += 1;
      }
      chanend_all_sent(x);
      ctrl = chanend_read_word(x);
      chanend_all_received(x);
      chanend_free(x);
    }
    chanend_all_received(s);
  } while ((i == 0) && (--e > 0));
  chanend_free(s);
  return ctrl;
}

#endif
