/* copyright (c)2012 Oskar Schirmer <oskar@scara.com> */
#ifndef _PRINT_H
#define _PRINT_H

#include "resource.h"

static inline void printchar(const resource ch, const unsigned char b)
{
  chanend_write_byte(ch, b);
}

static inline void println(const resource ch)
{
  printchar(ch, 13);
  printchar(ch, 10);
  chanend_all_sent(ch);
}

static inline void printstr(const resource ch, const unsigned char *s)
{
  unsigned char b;
  while ((b = *s)) {
    printchar(ch, b);
    s++;
  }
}

static inline void printhex(const resource ch, unsigned data, unsigned digits)
{
  const static unsigned char hex[16] = "0123456789abcdef";
  int i;
  if (digits > 8)
    digits = 8;
  i = digits;
  do {
    printchar(ch, hex[(data >> (--i * 4)) & 0xf]);
  } while (i > 0);
}

#endif
